// multiwavDlg.cpp : implementation file
//

#include "stdafx.h"
#include "multiwav.h"
#include "multiwavDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMultiwavApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiwavDlg dialog

CMultiwavDlg::CMultiwavDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMultiwavDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMultiwavDlg)
	m_csInputFile = _T("");
	m_csOutputFile = _T("");
	m_iRadioMode = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMultiwavDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMultiwavDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Control(pDX, IDC_PROGRESS1, m_CProgress);
	DDX_Text(pDX, IDC_EDITIN, m_csInputFile);
	DDX_Text(pDX, IDC_EDITOUT, m_csOutputFile);
	DDX_Radio(pDX, IDC_RADIOMODE0, m_iRadioMode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMultiwavDlg, CDialog)
	//{{AFX_MSG_MAP(CMultiwavDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONIN, OnButtonin)
	ON_BN_CLICKED(IDC_BUTTONOUT, OnButtonout)
	ON_BN_CLICKED(IDC_RADIOMODE0, OnRadiomode0)
	ON_BN_CLICKED(IDC_RADIOMODE1, OnRadiomode1)
	ON_BN_CLICKED(IDABORT, OnAbort)
	ON_BN_CLICKED(IDC_BUTTONDEL, OnButtondel)
	//}}AFX_MSG_MAP
    ON_WM_DROPFILES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiwavDlg message handlers

BOOL CMultiwavDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	DragAcceptFiles(TRUE);

	EnableButtons();

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMultiwavDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMultiwavDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMultiwavDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMultiwavDlg::OnButtonin() 
{
	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo, csAux;

	UpdateData (TRUE);

	csFiltro  = "wave files (*.wav)|*.wav|";
	csFiltro += "All Files (*.*)|*.*|";
	csFiltro += "|";

	csTitulo = "Select input file";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(TRUE,"","",OFN_HIDEREADONLY | OFN_FILEMUSTEXIST,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
		NewInputFile( dlgAbrir.GetPathName() );

}

void CMultiwavDlg::NewInputFile( CString csFile)
{
	int nFile;
	CWnd * pWnd;
	CString csAux;

	UpdateData (TRUE);

	if (m_iRadioMode==1)
	{ // DE-INTERLEAVE
		if (!theApp.GetInputInfo(0,csFile))
		{
			m_csInputFile="";
//			MessageBox( "File is unknown or unsupported.", "Error",  MB_OK | MB_ICONEXCLAMATION );
		}
		else // if (m_csOutputFile=="")
		{
			m_csInputFile=csFile;
			m_csOutputFile= m_csInputFile.Left(m_csInputFile.ReverseFind('.'))+"_ch.wav";
			csAux.Format(_T(" %d Hz;  %d bits"),theApp.m_iFsample[0],theApp.m_nBits[0]);
			pWnd = GetDlgItem(IDC_STATICBITS);
			pWnd->SetWindowText(csAux);
			csAux.Format(_T("File is a %d channels wave"),theApp.m_nChannels[0]);
			pWnd = GetDlgItem(IDC_STATICCHAN);
			pWnd->SetWindowText(csAux);
		}
	}
	else if (m_iRadioMode==0)
	{ // INTERLEAVE
		nFile=m_List.GetCount();
		if (nFile >= MAXCHAN)
			MessageBox( "Too Many Files.", "Error",  MB_OK | MB_ICONEXCLAMATION );
		else if (AlreadyInList(csFile))
			MessageBox( "File is already included in the list.", "Error",  MB_OK | MB_ICONEXCLAMATION );
		else if (!theApp.GetInputInfo(nFile,csFile))
			nFile=nFile;
//			MessageBox( "File is unknown or unsupported.", "Error",  MB_OK | MB_ICONEXCLAMATION );
		else if (theApp.m_nChannels[nFile]!=1)
			MessageBox( "This file is not a single channel wave.", "Error",  MB_OK | MB_ICONEXCLAMATION );
		else
		{
			if (nFile==0)
			{
				csAux.Format(_T(" %d Hz;  %d bits"),theApp.m_iFsample[0],theApp.m_nBits[0]);
				pWnd = GetDlgItem(IDC_STATICBITS);
				pWnd->SetWindowText(csAux);
			}
			m_List.AddString(csFile);
			SetHorizontalScroll();
		}
	}
	UpdateData (FALSE);	
	EnableButtons();

}
void CMultiwavDlg::OnButtonout() 
{
	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo;

	// String del filtro de ficheros y del titulo
	UpdateData (TRUE);

	csFiltro  = "wave files (*.wav)|*.wav||";
	csTitulo = "Select output file";

	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(FALSE,"wav","",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csOutputFile = dlgAbrir.GetPathName(); 
		UpdateData (FALSE);
		EnableButtons();
	}		
}

void CMultiwavDlg::OnRadiomode0() 
{
	// TODO: Add your control notification handler code here
	int iOld;
	CWnd * pWnd;

	iOld=m_iRadioMode;
	UpdateData(TRUE);
	if (iOld==m_iRadioMode) return;

	m_csInputFile="";
	m_csOutputFile="";
//	theApp.ClearAll();
	m_List.ResetContent();

	pWnd = GetDlgItem(IDC_STATICBITS);
	pWnd->SetWindowText("Unknown");
	pWnd = GetDlgItem(IDC_STATICCHAN);
	pWnd->SetWindowText("");

	UpdateData (FALSE);
	EnableButtons();
}

void CMultiwavDlg::OnRadiomode1() 
{
	// TODO: Add your control notification handler code here
	OnRadiomode0();
}

void CMultiwavDlg::OnAbort() 
{
	// TODO: Add your control notification handler code here
	theApp.m_bAbort=true;
	
}


void CMultiwavDlg::EnableButtons()
{
	CWnd * pWnd;


	UpdateData(TRUE);
	if (m_iRadioMode==0)
	{// INTERLEAVE
		pWnd = GetDlgItem(IDC_STATICDE);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_STATICIN);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_LIST1);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_EDITIN);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_STATICCHAN);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_BUTTONDEL);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_BUTTONIN);
		pWnd->SetWindowText(" Add ");
	}
	else
	{// DE-INTERLEAVE
		pWnd = GetDlgItem(IDC_STATICDE);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATICIN);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_LIST1);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_EDITIN);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATICCHAN);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_BUTTONDEL);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_BUTTONIN);
		pWnd->SetWindowText("Browse");

	}

	if (theApp.m_bProcessing)
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDOK);
		if (!m_csOutputFile.IsEmpty() && (!m_csInputFile.IsEmpty() || m_List.GetCount() ))
			pWnd->EnableWindow(TRUE);
		else
			pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(FALSE);
	}


	UpdateData(FALSE);
}



void CMultiwavDlg::OnDropFiles( HDROP hDropInfo)
{
	UINT nFiles;
	CWinApp* pApp;
	TCHAR szFileName[_MAX_PATH];
	CString csFile;

	SetActiveWindow();      // activate us first !
	POINT ThePoint;

	DragQueryPoint(hDropInfo,&ThePoint);

	nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);
	pApp = AfxGetApp();
	ASSERT(pApp != NULL);
	if(nFiles> 1)
	{
		MessageBox( "Only one file at a time!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
	}
	else if(nFiles== 1)
	{
		::DragQueryFile(hDropInfo, 0, szFileName, _MAX_PATH);

		csFile.Format(_T("%s"),szFileName);

		NewInputFile( csFile);

	}

	::DragFinish(hDropInfo);
}

void CMultiwavDlg::OnButtondel() 
{
	// TODO: Add your control notification handler code here
	CWnd * pWnd;

	m_csInputFile="";
//	theApp.ClearAll();
	m_List.ResetContent();

	pWnd = GetDlgItem(IDC_STATICBITS);
	pWnd->SetWindowText("Unknown");

	UpdateData (FALSE);
	EnableButtons();	
}

void CMultiwavDlg::SetHorizontalScroll() 
{
// Find the longest string in the list box.
	CString str;
	CSize   sz;
	int     dx=0;
	CDC*    pDC = m_List.GetDC();

	for (int i=0;i < m_List.GetCount();i++)
	{
		m_List.GetText( i, str );
		sz = pDC->GetTextExtent(str);
		if (sz.cx > dx)
			dx = sz.cx;
	}
	m_List.ReleaseDC(pDC);

// Set the horizontal extent so every character of all strings 
// can be scrolled to.
	m_List.SetHorizontalExtent(dx);
}

bool CMultiwavDlg::AlreadyInList(CString csFile) 
{
// Find the longest string in the list box.
	CString csAux;
	int i;
	bool bAlready=false;

	for (i=0;i < m_List.GetCount() && bAlready==false;i++)
	{
		m_List.GetText( i, csAux );
		if (csAux==csFile)
			bAlready=true;
	}
	return bAlready;
}

void CMultiwavDlg::UpdateProgress(int nPerc)
{
//	CWnd * pWnd;

	if (nPerc <0 ) nPerc=0;
	if (nPerc >100 ) nPerc=100;
	m_CProgress.SetPos(nPerc);

}

void CMultiwavDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	CDialog::OnCancel();
}


void CMultiwavDlg::OnOK() 
{
	// TODO: Add extra validation here
	int i, n, iRet;


	theApp.m_bAbort=false;

	UpdateData(TRUE);
	if (m_csOutputFile.IsEmpty())
	{
		MessageBox( "Fill output file path!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	if (m_iRadioMode==1)
	{
//DE-INTERLEAVE
		if (m_csInputFile.IsEmpty())
		{
			MessageBox( "Fill input file path!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}

		theApp.m_csInputFile[0]=m_csInputFile;
		theApp.m_csOutputFile=m_csOutputFile;

		theApp.m_bProcessing=true;
		EnableButtons();
		iRet=theApp.ExeDeILV(this);
	}
	else if (m_iRadioMode==0)
	{
//INTERLEAVE
		n=m_List.GetCount();
		if ( n<2 )
		{
			MessageBox( "Fill more than two input file paths!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}

		for (i=0;i < n ;i++)
		{
			m_List.GetText( i, theApp.m_csInputFile[i] );
		}

		theApp.m_csOutputFile=m_csOutputFile;

		theApp.m_bProcessing=true;
		EnableButtons();
		iRet=theApp.ExeILV(n,this);
	}

	if (theApp.m_bAbort==true)
		MessageBox( "Aborted!.", "Info",  MB_OK | MB_ICONINFORMATION );
	else if (iRet==1)
		MessageBox( "Finished OK!.", "Info",  MB_OK | MB_ICONINFORMATION );
	else 
		MessageBox( "Finished with error!.", "Info",  MB_OK | MB_ICONINFORMATION );

	m_CProgress.SetPos(0);

	theApp.m_bProcessing=false;
	EnableButtons();
	return;
	CDialog::OnOK();
}
