// multiwavDlg.h : header file
//

#if !defined(AFX_MULTIWAVDLG_H__9BBE8B6F_E3B1_452E_9427_8B6BAD495175__INCLUDED_)
#define AFX_MULTIWAVDLG_H__9BBE8B6F_E3B1_452E_9427_8B6BAD495175__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMultiwavDlg dialog

class CMultiwavDlg : public CDialog
{
// Construction
public:
	CMultiwavDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMultiwavDlg)
	enum { IDD = IDD_MULTIWAV_DIALOG };
	CListBox	m_List;
	CProgressCtrl	m_CProgress;
	CString	m_csInputFile;
	CString	m_csOutputFile;
	int		m_iRadioMode;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultiwavDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMultiwavDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonin();
	afx_msg void OnButtonout();
	afx_msg void OnRadiomode0();
	afx_msg void OnRadiomode1();
	afx_msg void OnAbort();
	afx_msg void OnButtondel();
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG

	virtual void EnableButtons();
	virtual void NewInputFile( CString csFile);
	virtual void OnDropFiles( HDROP hDropInfo);
	virtual void SetHorizontalScroll();
	virtual bool AlreadyInList(CString csFile);
public:
	virtual void UpdateProgress(int nPerc);



	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTIWAVDLG_H__9BBE8B6F_E3B1_452E_9427_8B6BAD495175__INCLUDED_)
